"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.SchemaDownloader = void 0;
var async_toolbox_1 = require("async-toolbox");
var contentful_management_1 = require("contentful-management");
var SchemaDownloader = /** @class */ (function () {
    function SchemaDownloader(options, fs) {
        var _this = this;
        this.requestLogger = function (config) {
            // console.log('req', config)
        };
        this.responseLogger = function (response) {
            _this.options.logger.debug(response.status, response.config.url);
        };
        var opts = Object.assign({
            filename: './contentful-schema.json',
            managementToken: process.env.CONTENTFUL_MANAGEMENT_TOKEN,
            space: process.env.CONTENTFUL_SPACE_ID,
            environment: process.env.CONTENTFUL_ENVIRONMENT || 'master',
            logger: { debug: function () { return undefined; } }
        }, options);
        if (!opts.managementToken) {
            throw new Error('No managementToken given!');
        }
        this.options = opts;
        this.client = contentful_management_1.createClient({
            accessToken: opts.managementToken,
            requestLogger: this.requestLogger,
            responseLogger: this.responseLogger
        });
        this.semaphore = new async_toolbox_1.Limiter({
            interval: 'second',
            tokensPerInterval: 4
        });
        this.fs = fs || require('fs-extra');
    }
    SchemaDownloader.prototype.downloadSchema = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, contentTypes, editorInterfaces;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getSchemaFromSpace()
                        // Use callback API to avoid dependency on fs-extra
                    ];
                    case 1:
                        _a = _b.sent(), contentTypes = _a.contentTypes, editorInterfaces = _a.editorInterfaces;
                        // Use callback API to avoid dependency on fs-extra
                        return [2 /*return*/, new Promise(function (res, rej) {
                                _this.fs.writeFile(_this.options.filename, JSON.stringify({
                                    contentTypes: contentTypes,
                                    editorInterfaces: editorInterfaces
                                }, undefined, '  '), function (ex) {
                                    if (ex) {
                                        return rej(ex);
                                    }
                                    // contentful-shell and the wcc-contentful gem both add a newline at the end of the file.
                                    _this.fs.appendFile(_this.options.filename, '\n', function (ex) {
                                        if (ex) {
                                            return rej(ex);
                                        }
                                        res();
                                    });
                                });
                            })];
                }
            });
        });
    };
    SchemaDownloader.prototype.getSchemaFromSpace = function () {
        return __awaiter(this, void 0, void 0, function () {
            var space, env, contentTypesResp, editorInterfaces, contentTypes;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.semaphore.lock(function () {
                            return _this.client.getSpace(_this.options.space);
                        })];
                    case 1:
                        space = _a.sent();
                        return [4 /*yield*/, this.semaphore.lock(function () {
                                return space.getEnvironment(_this.options.environment);
                            })];
                    case 2:
                        env = _a.sent();
                        return [4 /*yield*/, this.semaphore.lock(function () {
                                return env.getContentTypes();
                            })];
                    case 3:
                        contentTypesResp = _a.sent();
                        return [4 /*yield*/, Promise.all(contentTypesResp.items.map(function (ct) {
                                return _this.semaphore.lock(function () { return __awaiter(_this, void 0, void 0, function () {
                                    var _a, _b;
                                    return __generator(this, function (_c) {
                                        switch (_c.label) {
                                            case 0:
                                                _a = sortControls;
                                                _b = stripSys;
                                                return [4 /*yield*/, ct.getEditorInterface()];
                                            case 1: return [2 /*return*/, _a.apply(void 0, [_b.apply(void 0, [(_c.sent())
                                                            .toPlainObject()])])];
                                        }
                                    });
                                }); });
                            }))];
                    case 4:
                        editorInterfaces = (_a.sent()).sort(byContentType);
                        contentTypes = contentTypesResp.items.map(function (ct) {
                            return stripSys(ct.toPlainObject());
                        })
                            .sort(byId);
                        return [2 /*return*/, {
                                contentTypes: contentTypes,
                                editorInterfaces: editorInterfaces
                            }];
                }
            });
        });
    };
    return SchemaDownloader;
}());
exports.SchemaDownloader = SchemaDownloader;
function stripSys(obj) {
    return __assign(__assign({}, obj), { sys: {
            id: obj.sys.id,
            type: obj.sys.type,
            contentType: obj.sys.contentType
        } });
}
function sortControls(editorInterface) {
    return {
        sys: editorInterface.sys,
        controls: editorInterface.controls
            .sort(byFieldId)
            .map(function (c) { return ({
            fieldId: c.fieldId,
            settings: c.settings,
            widgetId: c.widgetId
        }); })
    };
}
function byId(a, b) {
    return a.sys.id.localeCompare(b.sys.id);
}
function byContentType(a, b) {
    return a.sys.contentType.sys.id.localeCompare(b.sys.contentType.sys.id);
}
function byFieldId(a, b) {
    return a.fieldId.localeCompare(b.fieldId);
}
//# sourceMappingURL=index.js.map