import type { Asset, Entry } from "contentful";
import { DeletedAsset, DeletedEntry } from "./dataSource";
export declare function tryParseJson(json: string): unknown | null;
export interface ContentType {
    sys: {
        id: string;
    };
    fields: ContentTypeField[];
}
export interface ContentTypeField {
    id: string;
    type: string;
    omitted?: boolean;
    required?: boolean;
    validations?: Array<unknown | LinkContentTypeValidation>;
    linkType?: 'Asset' | 'Entry';
    items?: {
        type: string;
        linkType?: 'Asset' | 'Entry';
        validations?: Array<unknown | LinkContentTypeValidation>;
    };
}
export interface LinkContentTypeValidation {
    linkContentType: string[];
}
export declare function isLinkContentTypeValidation(v: any): v is LinkContentTypeValidation;
export declare function idToName(id: string): string;
export declare function present(value: string | undefined | null | ''): value is string;
export declare function isEntry(e: any): e is Entry<any>;
export declare function isAsset(e: any): e is Asset;
export declare function isDeletedEntry(e: any): e is DeletedEntry;
export declare function isDeletedAsset(e: any): e is DeletedAsset;
