"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.isDeletedAsset = exports.isDeletedEntry = exports.isAsset = exports.isEntry = exports.present = exports.idToName = exports.isLinkContentTypeValidation = exports.tryParseJson = void 0;
var inflection_1 = __importDefault(require("inflection"));
function tryParseJson(json) {
    try {
        return JSON.parse(json);
    }
    catch (ex) {
        return null;
    }
}
exports.tryParseJson = tryParseJson;
function isLinkContentTypeValidation(v) {
    return 'linkContentType' in v && Array.isArray(v.linkContentType);
}
exports.isLinkContentTypeValidation = isLinkContentTypeValidation;
function idToName(id) {
    id = inflection_1["default"].underscore(id);
    id = id.replace(/[^\w]/g, ' ');
    id = inflection_1["default"].titleize(id);
    id = id.replace(/[\s+]/g, '');
    return id;
}
exports.idToName = idToName;
function present(value) {
    if (!value) {
        return false;
    }
    if (!/\S/.test(value)) {
        return false;
    }
    return true;
}
exports.present = present;
function isEntry(e) {
    return e && e.sys && e.sys.type == 'Entry';
}
exports.isEntry = isEntry;
function isAsset(e) {
    return e && e.sys && e.sys.type == 'Asset';
}
exports.isAsset = isAsset;
function isDeletedEntry(e) {
    return e && e.sys && e.sys.type == 'DeletedEntry';
}
exports.isDeletedEntry = isDeletedEntry;
function isDeletedAsset(e) {
    return e && e.sys && e.sys.type == 'DeletedAsset';
}
exports.isDeletedAsset = isDeletedAsset;
//# sourceMappingURL=util.js.map